Attribute VB_Name = "Modul1"
Public objApp As Object
Public objDoc As Object
Public objSheet As Object
Public objBalloon As Object
Public objBalloons As Object
Public objSelect As Object
Public obj2del()
Public objNumber As Long
Public cOption As String
Public objDV As Object
Public SelectedDV As String
Public nBalloons As Long
Public i As Long
Public j As Long
Public aBalloonsText()

Sub main()

'Turn on error handling.
    On Error Resume Next

'Connect to a running instance of Solid Edge.
    Set objApp = GetObject(, "SolidEdge.Application")

    If Err Then
        MsgBox "Solid Edge not started"
        End
    End If

'Access the currently open document.
    Set objDoc = objApp.ActiveDocument

    If Err Or objDoc.Application.ActiveDocumentType <> 2 Then
        MsgBox "Solid Edge Draft Environment not loaded / activated"
        End
    End If

    Set objSheet = objDoc.ActiveSheet
    Set objBalloons = objSheet.Balloons
    
    If objBalloons.Count = 0 Then
        MsgBox "There are no balloons on the active sheet"
        End
    End If

    nBalloons = objBalloons.Count
    
    ReDim obj2del(nBalloons)
    ReDim aBalloonsText(nBalloons)

'Predefinition obj2del Array
    For i = 0 To nBalloons - 1
        obj2del(i) = "NA"
    Next

'Definition aBalloonsText Array
    For i = 0 To nBalloons - 1
        aBalloonsText(i) = objBalloons.Item(i + 1).BalloonText
    Next

'Show Option screen
    sKill_Balloons

End Sub
Sub sKill_Balloons()

    Kill_Balloon.Show

End Sub
Sub Delete_Balloons()

'Delete the balloons marked in obj2del.
'Delete from the last to avoid problems with the dynamic SE array
    For i = nBalloons - 1 To 0 Step -1
        If obj2del(i) <> "NA" Then
            Set objSelect = objBalloons.Item(i + 1)
            objSelect.Delete
        End If
    Next

End Sub
Sub SetDV()
    
'get the selected drawing view and set "SelectedDV"
    If GetSelectedDV(objDoc, objDV) Then
        SelectedDV = objDV.Name
    End If
        
    If SelectedDV = "" Then
        MsgBox "No drawing view selected. Select a drawing view and run the macro again."
        End
    End If
   
End Sub

'this Function returns the selcted drawing view
Function GetSelectedDV(ByVal objDft As Object, ByRef objDW As Object) As Boolean
  
  On Error GoTo ErrorHandler
  
    If objDft.SelectSet.Count <> 1 Then Exit Function
    If objDft.SelectSet(1).Type = igDrawingView Then
        Set objDW = objDft.SelectSet(1)
        GetSelectedDV = True
    End If
ErrorHandler:

End Function

'Delete the double balloons in the selcted drawing view
Sub SelectUser()

    Dim x As Double
    Dim y As Double
    Dim z As Double
    Dim bKeypoint As Boolean
    Dim objTerminator As Object
    Dim objGraphicMember As Object
    
    Dim aBalloonsDV()
    
    'call SetDV to get the drawing view name
    SetDV

    ReDim aBalloonsDV(nBalloons)

    'Write the drawing view of each balloon to Array aBalloonsDV
    For i = 0 To nBalloons - 1
        Set objBalloon = objBalloons.Item(i + 1)
        Call objBalloon.GetTerminator(objTerminator, x, y, z, bKeypoint)
        Set objGraphicMember = objTerminator.Object
        Set objDV = objGraphicMember.DrawingView
        aBalloonsDV(i) = objDV.Name
    Next

    'Compare values and mark the double balloons to delete in obj2del
    For i = 0 To nBalloons - 1
        If aBalloonsDV(i) = SelectedDV Then
            For j = 0 To nBalloons - 1
                If aBalloonsText(i) = aBalloonsText(j) And aBalloonsDV(j) <> SelectedDV Then
                    obj2del(i) = i
                End If
            Next
        End If
    Next

End Sub

'Delete the most recently placed double ballons
Sub SelectLast()

'Compare values and mark the double balloons to delete in obj2del
    For i = 0 To nBalloons - 1
        For j = i + 1 To (nBalloons - 1)
            If aBalloonsText(i) = aBalloonsText(j) Then
                obj2del(j) = j
            End If
        Next
    Next

End Sub

'Delete the double balloons placed first
Sub SelectFirst()

'Compare values and mark the double balloons to delete in obj2del
    For i = nBalloons - 1 To 1 Step -1
        For j = i - 1 To 1 Step -1
            If aBalloonsText(i) = aBalloonsText(j - 1) Then
                obj2del(j - 1) = j
            End If
        Next
    Next

End Sub

